/*
This class will attempt to build an airport at a given location. 
*/


class AirportBuilder
{

	constructor()
	{
	
	}
	
}

function AirportBuilder::Begin(companyIdx)
{
	GSSign.BuildSign(100, "testing"); 
	GSCompanyMode(companyIdx); 
	GSLog.Info("Switched to mode for " + GSCompany.GetName(companyIdx)); 
	//GSExecMode(); 
	
	local airportType = GSAirport.AT_SMALL; 
	
	local tileIdx; 
	
	local findTile = true; 
	
	while(findTile)
	{
		tileIdx = GSBase.RandRange(GSMap.GetMapSize());
		GSLog.Info("Trying tile " + tileIdx); 
		if (GSTile.IsBuildableRectangle(tileIdx, GSAirport.GetAirportWidth(airportType), GSAirport.GetAirportHeight(airportType)))
		{
			//if (GSTile.LevelTiles(tileIdx, GetTileIndexDistanceAway(tileIdx, GSAirport.GetAirportWidth(airportType), GSAirport.GetAirportHeight(airportType))))
			//{
				findTile = false; 
			//}
			// else
			// {
				// GSLog.Error("Unable to level tiles"); 
				// GSLog.Error(GSError.GetLastErrorString()); 
				// GSController.Sleep(100);

			// }
		}		
	}
	
	GSLog.Info("Trying to build airport"); 
	GSSign.BuildSign(tileIdx, "Attempting to build airport here"); 
	BuildAirport(tileIdx, airportType); 
}

function AirportBuilder::BuildAirport(tileIdx, airportType)
{
	if (!GSAirport.BuildAirport(tileIdx, airportType, GSStation.STATION_NEW))
	{
		GSLog.Error(GSError.GetLastErrorString()); 
		if (GSMap.IsValidTile(tileIdx))
		{
			GSLog.Info("Is valid Tile"); 
		}
		if (GSAirport.IsValidAirportType(airportType))
		{
			GSLog.Info("Airport is available"); 
		}
		
	}
}

//Gets the index of a tile a certain distance away. 
function AirportBuilder::GetTileIndexDistanceAway(tileIndex, xDistance, yDistance)
{
	local X = GSMap.GetTileX(tileIndex); 
	local Y = GSMap.GetTileY(tileIndex); 
	
	return GSMap.GetTileIndex(X + xDistance, Y + yDistance);
}